<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('books_published', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('department_id');
            $table->unsignedBigInteger('faculty_id'); // Faculty who uploaded the publication
            $table->text('author');
            $table->string('title');
            $table->string('publisher');
            $table->string('issn', 9)->nullable();
            $table->date('date_of_publication');
            $table->string('proof')->nullable(); // For file path

            // Foreign keys
            $table->foreign('department_id')->references('id')->on('departments')->onDelete('cascade');
            $table->foreign('faculty_id')->references('id')->on('users')->onDelete('cascade');

            // Indexes for better performance
            $table->index('department_id');
            $table->index('faculty_id');

            $table->timestamps();
        });
        // Add ISSN format check constraint manually


    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('books_published');
    }
};
